/*************************************/ 
/* Original oroborus window manager  */
/* (c) Ken Lynch Jan 2001            */
/*                                   */
/* Extra functionality for OroborOSX */
/* (c) Adrian Umpleby Sept 2001      */
/*                                   */
/* Distributed under the GPL         */ 
/* See LICENSE for more details      */ 
/*************************************/ 

/* common.h */

/*
 * This contains the info that both the 'oroborus part' and thhe 'Carbon part'
 * of OroborOSX need to know about
 */
 
#include "definitions.h"

#define PROGNAME		"OroborOSX"

#define MOUSE_STOPPED	-1
#define MOUSE_NORMAL	0
#define MOUSE_MOVE	1
#define MOUSE_RESIZE	2
#define MOUSE_CLOSE	3
#define MOUSE_HIDE	4
#define MOUSE_CLOSE_OUT	5
#define MOUSE_HIDE_OUT	6
#define MOUSE_OVERCLOSE	7
#define MOUSE_OVERHIDE	8
#define MOUSE_ICON	9
#define MOUSE_ICON_OUT	10

#define ICONBARPOS_TOPLEFT	0
#define ICONBARPOS_TOPRIGHT	1
#define ICONBARPOS_BOTLEFT	2
#define ICONBARPOS_BOTRIGHT	3

#define	menuApplication		128	/* Application menu ID */
#define	itemAbout		1

#define menuLaunch		129	/* Launch menu ID */
#define itemEditStart		1
#define itemNewItem		3
#define itemEditItems		4
#define itemxinitrc		6
#define itemxterm		8
#define itemxedit		9
#define itemxbiff		10
#define itemxclock		11
#define itemxeyes		12
#define itemxcalc		13
#define itemUserItems		14
// The rest of these are not actually used - they are just to remind of the default for the user part
#define itemETerm		15
#define itemGimp		16
#define itemNEdit		17

#define	menuEdit		130	/* Edit menu ID */

#define	menuOptions		131	/* Options menu ID */
#define itemHideIconbars	1
#define itemTopLeft		3
#define itemTopRight		4
#define itemBotLeft		5
#define itemBotRight		6
#define itemSlowIconbars	8
#define itemMedIconbars		9
#define itemFastIconbars	10
#define itemInterleave		12

#define	menuWindow		132	/* Window menu ID */
#define itemWindowshade		1
#define	itemMinimise		2
#define	itemZoom		3
#define itemFloat		5
#define itemAutoFocus		7
#define itemAutoRaise		8
#define	itemClose		10

#define	menuHelp		133	/* Help menu ID */
#define itemHelp		1

/* globals */
extern int myPathLen;
extern char myPath[512];
extern int gQuitFlag;
extern int gX11InFront, on_cmd_line, gInterleaving_Windows, gHiding_Iconbars;
extern int mouse_mode, real_x, real_y, iconbarpos, diffscrn_x, diffscrn_y;
extern long lastBackTicks, lastIconbarOutTicks;
extern char *Display_Name, *xpidstr;

/* main.c */
extern void Bring_To_Front(int quick);
extern void Bring_X_To_Front(int quick);
extern void Bring_OOSX_To_Front();
extern long MakeWindow(char *title, int windowtype);
extern void FocusOSXWin(long winref);
extern void DestroyOSXWindow(long winref);
extern void CheckOSXWinTitle(long winref, char *title);
extern void HideOSXWin(long winref);
extern void will_hide_all_iconbars();
extern void Setup_Options_Menu(int which);
extern void Setup_Window_Menu(int has_frame, int has_close, int has_min, int has_zoom, int is_float, int can_af, int can_ar);
extern void Compare_Screens(int scrnx, int scrny, int x11x, int x11y);
extern void Stop_XDarwin();
extern void Restart_XDarwin();

/* oroborus.c */
extern void quit();
extern int orob_main();

/* event.c */ 
extern void do_event_loop(int sleepus, int mouse_moved); 
extern void force_ungrab();

/* client.c */
extern void gone_to_back();
extern void come_to_front();
extern void change_focus(long winref);
extern void hide_all_iconbars();
extern void manipulate_focus_client(int action);
extern void change_options(int newattr);
extern void raise_all_clients();
